SystemOrganization addCategory: #'Glamour-Morphic-Widgets'!
SystemOrganization addCategory: 'Glamour-Morphic-Widgets-Popper'!

SmalltalkEditor subclass: #GLMSmalltalkEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMSmalltalkEditor commentStamp: 'TudorGirba 7/14/2011 22:07' prior: 0!
GLMSmalltalkEditor is a helper class for Glamour. The only goal for this class is to provide the hook needed to let the morph know when the selection has changed.!

!GLMSmalltalkEditor class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 7/28/2011 23:35'!
initialize
	"Initialize the keyboard shortcut maps and the shared buffers
	for copying text across views and managing again and undo." 
	super initialize! !

!GLMSmalltalkEditor methodsFor: 'new selection' stamp: 'TudorGirba 7/14/2011 22:40'!
storeSelectionInParagraph
	super storeSelectionInParagraph.
	self morph ifNotNil: [
		self morph editView 
			announceSelection: self selection
			from: self startIndex 
			to: self stopIndex - 1 ]! !

RubEditingArea subclass: #GLMRubricTextFieldArea
	instanceVariableNames: 'enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMRubricTextFieldArea methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/7/2014 23:29'!
click
	"empty"! !

!GLMRubricTextFieldArea methodsFor: 'defaults' stamp: 'AliakseiSyrel 10/7/2014 21:27'!
defaultMargins
	^ 1 @ 1 corner: 10 @ 1! !

!GLMRubricTextFieldArea methodsFor: 'protocol' stamp: 'AliakseiSyrel 10/7/2014 22:13'!
disable

	self isEnabled ifFalse: [ ^ self ].
	
	enabled := false.
	self editingMode: RubPlainTextMode new.! !

!GLMRubricTextFieldArea methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/8/2014 02:01'!
doubleClick: anEvent

	self isEnabled ifTrue: [ ^ self ].
	
	self isEnabled ifFalse: [
		self enable.
		super mouseDown: anEvent ]! !

!GLMRubricTextFieldArea methodsFor: 'protocol' stamp: 'AndreiChis 10/10/2014 16:26'!
enable

	self isEnabled ifTrue: [ ^ self ].
	
	enabled := true.
	self editingMode: RubSmalltalkCodeMode new.! !

!GLMRubricTextFieldArea methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/7/2014 21:47'!
focusChanged
	super focusChanged.
	
	self hasFocus ifFalse: [
		self disable.
	].! !

!GLMRubricTextFieldArea methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/7/2014 22:05'!
handlesMouseOver: evt

	^ self isEnabled! !

!GLMRubricTextFieldArea methodsFor: 'initialize' stamp: 'AliakseiSyrel 10/8/2014 01:48'!
initialize
	super initialize.
	
	enabled := false.
	self backgroundColor: Color transparent.! !

!GLMRubricTextFieldArea methodsFor: 'testing' stamp: 'AliakseiSyrel 10/7/2014 21:37'!
isEnabled

	^ enabled! !

!GLMRubricTextFieldArea methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/7/2014 21:01'!
keyStroke: evt
	evt keyValue = Character cr asciiValue
		ifTrue: [ 
			| answer |
			self announce: (answer := RubReturnEntered morph: self).
			answer accepted
				ifTrue: [ self editor textWasAccepted ] ]
		ifFalse: [ super keyStroke: evt ]! !

!GLMRubricTextFieldArea methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/8/2014 02:02'!
mouseDown: event
	|selectors|
	self isEnabled ifTrue: [ ^ super mouseDown: event ].
	
	selectors := Array
				with: nil
				with: #doubleClick:
				with: #singleClick:
				with: (self dragEnabled
						ifTrue: [#startDrag:]).
	event hand
		waitForClicksOrDrag: self
		event: event
		selectors: selectors
		threshold: 10.! !

!GLMRubricTextFieldArea methodsFor: 'private' stamp: 'AliakseiSyrel 10/7/2014 21:01'!
newParagraph
	^ RubExtraSelectionDecorator next: super newParagraph! !

!GLMRubricTextFieldArea methodsFor: 'editing' stamp: 'AliakseiSyrel 10/8/2014 01:03'!
privateReplaceFrom: start to: stop with: aText
	| newText  |
	newText := aText.
	" it is possible to have cr in case of copy-paste "
	(aText string includesAnyOf: {(Character cr). (Character lf)})
		ifTrue: [ 
			newText := newText asString copyReplaceAll: String cr with: '' asTokens: false.
			newText := newText asString copyReplaceAll: String lf with: '' asTokens: false ].
	super privateReplaceFrom: start to: stop with: newText! !

!GLMRubricTextFieldArea methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/8/2014 02:28'!
singleClick: anEvent
	
	self isEnabled ifTrue: [ ^ super click: anEvent ].

	"sorry for such a dirty hack"
	self owner owner owner owner owner container listManager mouseUp: anEvent on: self owner owner owner owner owner.! !

!GLMRubricTextFieldArea methodsFor: 'settings' stamp: 'AliakseiSyrel 10/7/2014 21:06'!
walkAlongDisplayedLine
	^ false! !

StandardWindow subclass: #GLMSystemWindow
	instanceVariableNames: 'toolbarBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMSystemWindow commentStamp: 'TudorGirba 1/27/2011 22:09' prior: 0!
This is the window in which the Glamour browsers are rendered in Morphic.!

!GLMSystemWindow methodsFor: 'announcement' stamp: 'TudorGirba 2/3/2011 09:06'!
allKeystrokeActions
	^ self model notNil 
		ifTrue: [
			(self model allActions, self model allSelectionActions) select: [ :action | 
				action hasShortcut ]]
		ifFalse: [#()]! !

!GLMSystemWindow methodsFor: 'open/close' stamp: 'TudorGirba 2/3/2011 09:06'!
delete
	self model notNil ifTrue: [self model unregisterFromAllAnnouncements].
	super delete! !

!GLMSystemWindow methodsFor: 'building' stamp: 'TudorGirba 1/27/2011 23:35'!
extent: aPoint 
	super extent: aPoint.
	self fullBounds! !

!GLMSystemWindow methodsFor: 'event handling' stamp: 'TudorGirba 1/31/2011 23:16'!
handleKeyStroke: anEvent
	| action |
	action := self allKeystrokeActions detect: [:a | 
		anEvent commandKeyPressed and: [ 
			a shortcut = anEvent keyCharacter ]] ifNone: [nil].
	action ifNotNil: [ self announcer announce: (GLMKeyStroke action: action) ]! !

!GLMSystemWindow methodsFor: 'initialization' stamp: 'TudorGirba 5/28/2012 00:27'!
initialize 
	super initialize.
	self
		on: #keyStroke 
		send: #handleKeyStroke: 
		to: self	! !

!GLMSystemWindow methodsFor: 'accessing' stamp: 'TudorGirba 1/27/2011 23:02'!
toolbarBox: anObject
	toolbarBox := anObject.
	self replacePane: menuBox with: toolbarBox! !

!GLMSystemWindow methodsFor: 'announcement' stamp: 'TudorGirba 1/31/2011 23:08'!
when: anAnnouncement do: aBlock 
	^ self announcer when: anAnnouncement do: aBlock! !

PaginatedMorphTreeModel subclass: #GLMTreeMorphModel
	instanceVariableNames: 'roots glamourPresentation childrenBlock onSelection displayFormat tagsToFilterBy glmAnnouncer inputText amountToFilterBy defaultPageSize columnToSortBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMTreeMorphModel commentStamp: 'alain.plantec 9/8/2009 15:22' prior: 0!
ClassTree new openOn: Collection
!

!GLMTreeMorphModel methodsFor: 'drag and drop' stamp: 'TudorGirba 1/3/2012 00:06'!
acceptDroppingMorph: transferMorph event: evt inMorph: listMorph 
	| targetItem |
	targetItem := (listMorph scrollerSubMorphFromPoint: evt position) complexContents item.	
	^ self glamourPresentation accept: transferMorph passenger droppedOnItem: targetItem! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 11/25/2010 13:21'!
allKeystrokeActions
	^ (self glamourPresentation allActions, self glamourPresentation allSelectionActions) select: [ :action | 
		action hasShortcut ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'cyrilledelaunay 8/9/2011 13:14'!
allMenuActions
	^ (self glamourPresentation allSelectionActions select: [:action | action hasTitle ]) ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/18/2010 23:59'!
amountToFilterBy
	^ nil "amountToFilterBy ifNil: [self glamourPresentation amountToShow]"! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 12:05'!
amountToFilterBy: aNumber 
	amountToFilterBy := aNumber! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:17'!
announce: anAnnouncement
	self announcer announce: anAnnouncement ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/13/2012 13:16'!
announcer
	^glmAnnouncer ifNil: [ glmAnnouncer := GLMAnnouncer new ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:24'!
childrenBlock
	^ childrenBlock ifNil: [ childrenBlock := self glamourPresentation children isNil 
		ifFalse: [self glamourPresentation children] ifTrue: [OrderedCollection new] ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
childrenBlock: aBlock
	childrenBlock := aBlock ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/19/2010 00:12'!
defaultPageSize
	^ defaultPageSize! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/18/2010 23:54'!
defaultPageSize: anInteger
	defaultPageSize := anInteger! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:23'!
displayFormat
	^ displayFormat ifNil: [displayFormat := self glamourPresentation format]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
displayFormat: aBlock 
	displayFormat := aBlock ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'AndreiChis 6/13/2014 12:32'!
displayValue
	
	^ columnToSortBy 
		ifNil: [self glamourPresentation displayValue]
		ifNotNil: [self glamourPresentation displayValue sorted: self sortBlock]! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'usmanbhatti 3/10/2015 16:35'!
doSearchOrFilter
	inputText isEmptyOrNil
		ifTrue: [ self resetInput ]
		ifFalse:[ 
			self glamourPresentation allowsFilter 
				ifTrue: [ self executeFilter ]
				ifFalse: [ self executeSearch ] ].
! !

!GLMTreeMorphModel methodsFor: 'drag and drop' stamp: 'TudorGirba 1/3/2012 16:31'!
dragEnabled
	^ self glamourPresentation allowsItemDrag! !

!GLMTreeMorphModel methodsFor: 'drag and drop' stamp: 'TudorGirba 1/3/2012 16:28'!
dragPassengerFor: item inMorph: listMorph
	^ self glamourPresentation transformedDraggedItem: item complexContents item ! !

!GLMTreeMorphModel methodsFor: 'drag and drop' stamp: 'TudorGirba 1/2/2012 03:07'!
dragTransferType
	^ #Glamour! !

!GLMTreeMorphModel methodsFor: 'drag and drop' stamp: 'TudorGirba 1/2/2012 03:07'!
dragTransferTypeForMorph: listMorph
	^ self dragTransferType! !

!GLMTreeMorphModel methodsFor: 'drag and drop' stamp: 'TudorGirba 1/3/2012 08:36'!
dropEnabled
	^ self glamourPresentation isDropTarget! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'TudorGirba 4/4/2012 19:52'!
executeFilter
	self updateRoots! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 8/18/2010 16:38'!
executeSearch
	| newSelection check |
	newSelection := OrderedCollection new.
	roots do: [ :each | 
		check := self glamourPresentation searchStrategy value: self inputText value: each item.
		check ifTrue: [newSelection add: each path]].
	newSelection isEmpty 
		ifFalse: [ self selection: (MorphTreeMorphMultipleSelection new selectedNodePathList: newSelection) ]
		ifTrue: [self selection: nil]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 2/28/2010 21:28'!
explicitSelection: anObject 
	"anObject is a domain object, not a Glamour related object"
	self glamourPresentation isMultiple 
		ifTrue: [ self explicitlySelectMultipleItems: anObject ]
		ifFalse: [ self explicitlySelectItem: anObject ]! !

!GLMTreeMorphModel methodsFor: 'private selecting' stamp: 'cyrilledelaunay 7/22/2011 12:38'!
explicitlySelectItem: anObject 
	(self selectedItem notNil and: [self selectedItem = anObject]) ifTrue: [ ^ self ].
	(self selectedItem isNil and: [ anObject isNil ]) ifTrue: [ ^ self ].
	anObject isNil ifTrue: [
		"we make sure to update the morph list by deselecting everything"
		self selectNodePath: nil.
		self selection: nil.].
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			each item = anObject ifTrue: [
				each expandParentPath.
				self selectNodePath: each path.
				^ self]]]! !

!GLMTreeMorphModel methodsFor: 'private selecting' stamp: 'tg 1/11/2010 22:02'!
explicitlySelectMultipleItems: aCollection 
	| newSelection collection|
	aCollection isNil ifTrue: [^ self].
	collection := aCollection isCollection ifTrue: [aCollection] ifFalse: [aCollection asOrderedCollection ].
	(self selection notNil and: [
		self selection selectedItemOrItemsOrNil = collection asOrderedCollection ]) ifTrue: [ ^ self ].
	newSelection := OrderedCollection new.
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			(collection includes: each item) ifTrue: [
				newSelection add: each path ]]].
	self selectAllNodePaths: newSelection! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'AndreiChis 4/21/2014 12:32'!
filteredRoots
	| filtered |
	roots ifNil: [ self roots: self displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation
	^ glamourPresentation! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/28/2009 01:24'!
inputText
	^ inputText ifNil: [inputText := '']! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 23:05'!
inputText: anObject
	inputText := anObject.
	self doSearchOrFilter! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 16:29'!
inputTextEnabled
	^ true! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'TudorGirba 8/21/2011 22:58'!
keyStroke: aKeyboardEvent from: aTreeMorph 
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aKeyboardEvent keyCharacter] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/29/2009 16:45'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:20'!
nodeModelFor: anObject
	^ (GLMTreeMorphNodeModel with: anObject) containerTree: self; yourself! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 12/29/2009 02:01'!
onDoubleClick
	self announcer announce: (GLMTreeMorphStrongSelectionChanged new strongSelectionValue: 
		(self selection ifNotNil: [self selection selectedItemOrItemsOrNil]))! !

!GLMTreeMorphModel methodsFor: 'actions' stamp: 'DamienCassou 5/11/2011 08:10'!
resetChildrenContents 
	self roots do: [:each | each resetContentsRecursively]! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'TudorGirba 5/22/2013 13:34'!
resetInput
	self updateRoots! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'AlainPlantec 5/28/2012 07:35'!
resetTagsToFilterBy
	tagsToFilterBy := OrderedCollection new.
	self changed: #rootNodes.! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/13/2012 13:20'!
rootNodes
	^self roots! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'AndreiChis 4/21/2014 12:32'!
roots
	| filtered |
	roots ifNil: [ self roots: self displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	((self shouldFilterByAmount and: [
		self amountToFilterBy < filtered size]) and: [
			filtered notEmpty]) ifTrue: [
		filtered := filtered first: self amountToFilterBy ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 8/25/2013 22:46'!
roots: anObjectOrCollection
	roots := anObjectOrCollection asOrderedCollection 
				collect: [:each | self nodeModelFor: each ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 12/29/2009 01:57'!
selection: aSelection 
	self selection = aSelection ifTrue: [ ^ self ].
	super selection: aSelection.
	self announcer announce: (
			GLMTreeMorphSelectionChanged new 
				selectionValue: (aSelection ifNotNil: [aSelection selectedItemOrItemsOrNil]);
				selectionPathValue: self selectionPathItems;
				yourself)! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 11/29/2009 02:37'!
selectionPathItems
	^ self selectedNodePath isNil ifTrue: [nil] ifFalse: [self selectedNodePath collect: [:each | each item]]! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/30/2009 14:01'!
shouldFilterByAmount
	^ self amountToFilterBy notNil and: [self amountToFilterBy isZero not]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:29'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 11/13/2009 02:10'!
shouldFilterByTextInput
	^ self glamourPresentation allowsFilter and: [ self inputText notEmpty ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'AndreiChis 6/13/2014 12:30'!
sortBlock

	^ columnToSortBy sortBlock 
		ifNotNil: [ :aBlock | aBlock ]
		ifNil: [ 
			columnToSortBy defaultSortBlockForPresentation: self glamourPresentation ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'AndreiChis 6/13/2014 12:31'!
sortByColumn: aGlamourColumn

	columnToSortBy := (columnToSortBy == aGlamourColumn 
		ifTrue: [ nil ]
		ifFalse: [ aGlamourColumn ]).
	self updateRoots! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/13/2009 03:59'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'AlainPlantec 5/28/2012 07:35'!
toggleAmountToFilterBy
	self amountToFilterBy notNil ifTrue: 
		[ self amountToFilterBy isZero 
			ifTrue: [ amountToFilterBy := self glamourPresentation amountToShow ]
			ifFalse: [ amountToFilterBy := 0 ].
		self changed: #rootNodes ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'AlainPlantec 5/28/2012 07:35'!
toggleFilteringByTag: aTag 
	(self shouldFilterByTag: aTag) 
		ifTrue: [self tagsToFilterBy remove: aTag ]
		ifFalse: [self tagsToFilterBy add: aTag].
	self resetChildrenContents.
	self changed: #rootNodes! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'AlainPlantec 5/28/2012 07:35'!
updateRoots
	roots := nil.
	self changed: #rootNodes! !

!GLMTreeMorphModel methodsFor: 'drag and drop' stamp: 'AndreHora 2/14/2014 17:27'!
wantsDroppedMorph: transferMorph event: evt inMorph: listMorph 
	| targetItem targetItemMorph |
	(transferMorph isKindOf: TransferMorph) ifFalse: [ ^ false ].
	transferMorph dragTransferType = self dragTransferType ifFalse: [ ^ false ].
	
	targetItemMorph := (listMorph scrollerSubMorphFromPoint: evt position).
	targetItemMorph ifNotNil: [
		targetItem := targetItemMorph complexContents item.	
		^ self glamourPresentation allow: transferMorph passenger droppedOnItem: targetItem ].
	self flag: 'we should ask the whole presentation if it wants to receive a dropped object'.
	^ false! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:18'!
when: anAnnouncement do: aBlock
	self announcer when: anAnnouncement do: aBlock ! !

Morph subclass: #GLMPopper
	instanceVariableNames: 'textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets-Popper'!

!GLMPopper commentStamp: 'AndreiChis 10/1/2014 13:03' prior: 0!
This is a morph used for displaying various notifications.

It has a special ability to delete itself either when Esc is pressed, or when the focus is lost.

When opened the user has to spefify a text morph whose position and cursor are user to position this morph.

When triggered from a context menu action the class method installAlarmFor: should be used to open the popper as the text morph gets back the focus after the action was executed (and, hence, the popper is closed).!

GLMPopper subclass: #GLMErrorPopper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets-Popper'!

!GLMErrorPopper commentStamp: 'AndreiChis 10/1/2014 13:03' prior: 0!
I am a popper that displays an error message.

GLMErrorPopper simpleErrorPopper!

!GLMErrorPopper class methodsFor: 'examples' stamp: 'AndreiChis 10/1/2014 13:24'!
simpleErrorPopper
	"
	self simpleErrorPopper
	"

	(GLMErrorPopper new 
		withString: 'error message goes here' 
		from: RubScrolledTextMorph new) openInWorld! !

!GLMErrorPopper methodsFor: 'initialization' stamp: 'TudorGirba 8/1/2014 22:47'!
initialize
	super initialize.
	self initializeTextMorph! !

!GLMErrorPopper methodsFor: 'initialization' stamp: 'TudorGirba 8/1/2014 22:46'!
initializeTextMorph
	textMorph := RubScrolledTextMorph new.
	textMorph
		beReadOnly;
		beWrapped;
		color: Color paleRed.
	self
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		addMorph: textMorph fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1))! !

!GLMPopper class methodsFor: 'utils' stamp: 'AndreiChis 10/1/2014 11:46'!
installAlarmFor: aBlock

	World
		addAlarm: #value
		withArguments: #()
		for: aBlock
		at: Time millisecondClockValue + 50.! !

!GLMPopper methodsFor: 'public' stamp: 'AndreiChis 10/5/2014 21:40'!
computeOriginFor: aMorph
	| desiredTop desiredLeft |
	"self halt."
	aMorph textArea scrollSelectionIntoView: nil.
	desiredTop := aMorph textArea cursor positionInWorld y - 6.
						"unclear why 6 is the magic number"
	desiredLeft := aMorph textArea cursor right + aMorph positionInWorld x + 6.
	^ desiredLeft @ desiredTop! !

!GLMPopper methodsFor: 'initialization' stamp: 'TudorGirba 8/1/2014 22:47'!
initialize
	super initialize.
	self changeProportionalLayout.
	self
		onAnnouncement: MorphLostFocus do: [ :ann | ann morph delete ];
		color: Color transparent! !

!GLMPopper methodsFor: 'private' stamp: 'AndreiChis 10/1/2014 11:58'!
updateWithString: string from: aMorph
	textMorph
		updateTextWith: string;
		takeKeyboardFocus;
		on: Character escape do: [ 
			self delete.
			aMorph takeKeyboardFocus ];
		on: Character backspace do: [ 
			self delete.
			aMorph takeKeyboardFocus ];
		onAnnouncement: MorphLostFocus do: [ :ann | 
			self delete.
			"If this event is triggered then another morph already has the focus.
			Do not attempt to give the focus back to the original morph" ]! !

!GLMPopper methodsFor: 'private' stamp: 'TudorGirba 8/1/2014 23:01'!
withString: string from: aMorph
	| top width left stringMorph height desiredOrigin |
	desiredOrigin := self computeOriginFor: aMorph.
	stringMorph := RubEditingArea new updateTextWith: string.
	width := stringMorph width + 12 min: World width / 3.
	left := desiredOrigin x + width > World width
		ifTrue: [ World width - width ]
		ifFalse: [ desiredOrigin x ].
	height := (stringMorph
		beWrapped;
		width: width;
		yourself) height + 2 min: World height / 3.
	top := desiredOrigin y + height > World height
		ifTrue: [ World height - height ]
		ifFalse: [ desiredOrigin y ].
	self updateWithString: string from: aMorph.
	self
		top: top;
		left: left;
		width: width;
		height: height! !

GLMPopper subclass: #GLMPrintPopper
	instanceVariableNames: 'inspectButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets-Popper'!

!GLMPrintPopper commentStamp: 'AndreiChis 10/1/2014 13:24' prior: 0!
I am a popper that displays a notification message: I can display a given object or evaluate the selection of the attached text editor. 

I also offer a button for inspecting the object that is displayed.

GLMPrintPopper simpleObjectPopper
	
GLMPrintPopper selectionEvaluationPopper!

!GLMPrintPopper class methodsFor: 'examples' stamp: 'AndreiChis 10/1/2014 13:25'!
selectionEvaluationPopper
	"
	self selectionEvaluationPopper
	"
	GLMPrintPopper new 
		evaluateAndOpenFromRubric: (RubScrolledTextMorph new 
			beForSmalltalkCode;
			updateTextWith: '1+2+4';
			setSelection: (1to:6))! !

!GLMPrintPopper class methodsFor: 'examples' stamp: 'AndreiChis 10/1/2014 13:25'!
simpleObjectPopper
	"
	self simpleObjectPopper
	"

	GLMPrintPopper new 
		openFromRubric: RubScrolledTextMorph new 
		withResult: 'notification goes here'.! !

!GLMPrintPopper methodsFor: 'public' stamp: 'AndreiChis 10/1/2014 11:30'!
evaluateAndOpenFromRubric: aMorph

	self 
		openFromRubric: aMorph
		withResult: aMorph textArea editor evaluateSelection! !

!GLMPrintPopper methodsFor: 'initialization' stamp: 'TudorGirba 8/1/2014 22:47'!
initialize
	super initialize.
	self initializeInspectButton.
	self initializeTextMorph! !

!GLMPrintPopper methodsFor: 'initialization' stamp: 'AndreiChis 9/30/2014 16:58'!
initializeInspectButton

	inspectButton := MultistateButtonMorph new
		extent: GLMUIThemeExtraIcons glamorousInspect extent;
		activeEnabledOverUpFillStyle: (ImageFillStyle form: GLMUIThemeExtraIcons glamorousInspect);
		setBalloonText: 'Inspect' translated.
	self
		addMorph: inspectButton
		fullFrame: (LayoutFrame fractions: (1 @ 0 corner: 1 @ 0) offsets: (inspectButton width  @ 0 corner: 0 @ (2*inspectButton width) ))! !

!GLMPrintPopper methodsFor: 'initialization' stamp: 'AndreiChis 9/30/2014 16:55'!
initializeTextMorph
	textMorph := RubScrolledTextMorph new.
	textMorph
		beReadOnly;
		beWrapped;
		color: BalloonMorph balloonColor.
	self
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		addMorph: textMorph fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 0 corner: 0 @ 0))! !

!GLMPrintPopper methodsFor: 'public' stamp: 'AndreiChis 10/1/2014 11:25'!
openFromRubric: aMorph withResult: anObject
	| string |
	string := anObject asString.
	self withString: string from: aMorph.
	self width: self width + inspectButton width.
	textMorph
		on: $i command
		do: [ anObject inspect ].
	inspectButton addUpAction: [ anObject inspect ].
	self openInWorld! !

!Morph methodsFor: '*glamour-morphic-widgets' stamp: 'TudorGirba 1/16/2014 11:38'!
asReadOnlyMorph
	^ self! !

!Morph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 16:39'!
glamourMinExtent

	^ self minExtent! !

!Morph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/7/2011 10:37'!
glamourOptimalExtent

	|tmpOldResizing tmpResult|
	tmpOldResizing := self setOptimalResizingStrategyAndReturnOldOne. 
	tmpResult := self minExtent.
	self returnToOldResizingStrategy:  tmpOldResizing.
	^ tmpResult ! !

!Morph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 15:47'!
returnToOldResizingStrategy: aCollection

	|tmpSubmorphResizing|
	self submorphs with: aCollection third do: [:aMorph :resizingParameter |
		aMorph returnToOldResizingStrategy: resizingParameter.
		].
	self hResizing: aCollection first.
	self vResizing: aCollection second.! !

!Morph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 16:03'!
setOptimalResizing
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap! !

!Morph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 15:47'!
setOptimalResizingStrategyAndReturnOldOne
	| tmpHResizing tmpVResizing tmpSubmorphResizing |
	tmpHResizing := self hResizing.
	tmpVResizing := self vResizing.
	self setOptimalResizing.
	tmpSubmorphResizing := self submorphs collect: [ :aMorph | aMorph setOptimalResizingStrategyAndReturnOldOne ].
	^ {tmpHResizing.
	tmpVResizing.
	tmpSubmorphResizing}! !

TabGroupMorph subclass: #LazyTabGroupMorph
	instanceVariableNames: 'announcer toolbarMorph headerMorph tabSelectorWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 21:01'!
addLazyPage: aBlock label: aStringOrMorph
	self addLazyPage: aBlock label: aStringOrMorph toolbar: nil! !

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'TudorGirba 1/22/2011 22:03'!
addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar
	self addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar collapsable: false! !

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'AndreiChis 10/7/2014 11:52'!
addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar action: anActionMorphOrNil
	| newPage label |
	newPage := LazyTabPage new.
	newPage
		lazyPageMorphCreation: aBlock; 
		labelMorph: aStringOrMorph; 
		toolbar: aToolbar.
	label := self 
			buildLabelFrom: aStringOrMorph 
			withAction: anActionMorphOrNil.
	self 
		addPage: newPage
		label: label! !

!LazyTabGroupMorph methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:46'!
addLazyPage: aBlock label: aStringOrMorph toolbar: aToolbar collapsable: aBoolean
	| newPage label |
	newPage := LazyTabPage new.
	newPage
		lazyPageMorphCreation: aBlock; 
		labelMorph: aStringOrMorph; 
		toolbar: aToolbar.
	label := self 
			buildLabelFrom: aStringOrMorph 
			withAction: (aBoolean 
				ifTrue: [GLMActionButtonBrick new
					addUpAction: [self removePage: newPage];
					icon: self theme windowCloseForm ]
				ifFalse: [nil]).
	self 
		addPage: newPage
		label: label.
	! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 7/23/2011 20:14'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'AliakseiSyrel 10/17/2014 09:48'!
buildLabelFrom: aStringOrMorph withAction: anActionMorphOrNil
	| label innerLabel |

	innerLabel := aStringOrMorph isMorph
		ifTrue: [aStringOrMorph]
		ifFalse: [
			|container labelMorph|
			container := GLMBrick new.
			labelMorph := GLMLabelBrick new.
			labelMorph text: aStringOrMorph.
			labelMorph layoutProperties horizontalPercent: 100.
			container addBrickBack: labelMorph.
			container layoutProperties horizontalPercent: 100.
			labelMorph layoutProperties marginLeft: 5.
			
			container layoutProperties maxWidthBlock: [ :aTrick |
				labelMorph label textSize x + (2 *  labelMorph layoutProperties marginLeft) + (anActionMorphOrNil ifNotNil: [ anActionMorphOrNil normalImage width * 1.5 ] ifNil: [ 0 ])].
			container ].
		
	label := anActionMorphOrNil
			ifNil: [ innerLabel ]
			ifNotNil: [ 	anActionMorphOrNil layoutProperties horizontalPercent: 0.	anActionMorphOrNil layoutProperties minWidth: (anActionMorphOrNil normalImage width * 1.5). innerLabel addBrickBack: anActionMorphOrNil. innerLabel ].
					
	^ label! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 1/28/2011 01:25'!
headerMorph
	^ headerMorph! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 9/9/2014 12:46'!
headerMorph: anObject
	headerMorph := anObject.
	
	headerMorph clipSubmorphs: true.! !

!LazyTabGroupMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 9/4/2014 13:26'!
initialize
	"Initialize the receiver."

	super initialize.
	self removeMorph: self contentMorph;
		removeMorph: self tabSelectorMorph;  
		toolbarMorph: self newToolbarMorph;
		headerMorph: self newHeaderMorph;
		addMorph: self headerMorph;
		addMorph: self contentMorph.
	
"	self
		borderWidth: 0;
		changeTableLayout;
		cellPositioning: #topLeft;
		cellInset: 0 @ -1;
		reverseTableCells: true;
		pageMorphs: OrderedCollection new;
		tabSelectorMorph: self newTabSelectorMorph;
		contentMorph: self newContentMorph;
		addMorph: self tabSelectorMorph;
		addMorph: self contentMorph.
	self tabSelectorMorph addDependent: self"! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/11/2014 03:09'!
layoutChanged
	super layoutChanged.
	
	self headerMorph ifNotNil: [
		|newWidth|
		newWidth := self width.
		tabSelectorWidth = newWidth ifFalse: [
			tabSelectorWidth := newWidth.
			"the difference between TabSelectorMorph and the summ of widths of all tabs is 40. I don't know why"
			"self fitLabelsIn: tabSelectorWidth - self toolbarMorph width - 40."
		].
	].! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 20:38'!
newHeaderMorph
	^ (self theme 
			newRowIn: self theme
			for: {self tabSelectorMorph . self toolbarMorph}) cellInset: 0; cellPositioning: #bottomCenter; borderWidth: 0! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 10:19'!
newTabSelectorMorph
	"Answer a new tab selector morph"

	^ GLMTabSelectorBrick new
		vResizing: #shrinkWrap;
		hResizing: #spaceFill! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 20:36'!
newToolbarMorph
	^ PanelMorph new
		fillStyle: (SolidFillStyle color: Color transparent);
		borderStyle: (BorderStyle width: 0);
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		cellPositioning: #center;
		changeTableLayout;
		cellInset: 0;
		yourself ! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/22/2011 21:03'!
pageAt: index
	^ (self pages at: index ) actualPageMorph! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 7/23/2011 20:33'!
removePage: aPage
	| removedPageIndex |
	removedPageIndex := self pages indexOf: aPage.
	self announcer suspendAllWhile: [ super removePage: aPage ].
	self announcer announce: 
		(LazyTabPageRemoved new 
			tabs: self; 
			page: aPage; 
			pageIndex: removedPageIndex;
			newIndex: self tabSelectorMorph selectedIndex).
	self pages isEmpty 
		ifTrue: [ self contentMorph removeAllMorphs ]! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'TudorGirba 1/23/2011 00:23'!
removePageIndex: anInteger
	self removePage: (self pages at: anInteger)! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'TudorGirba 1/28/2011 00:33'!
toolbarMorph
	^ toolbarMorph! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 9/9/2014 12:46'!
toolbarMorph: anObject
	toolbarMorph := anObject.! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'AndreiChis 10/7/2014 11:50'!
updatePageAtIndex: anInteger withLabel: aStringOrMorph toolbar: aToolbar action: anActionMorph
	
	(self pages at: anInteger)
			toolbar: aToolbar.
	self 
		relabelPage: (self pages at: anInteger)
		with: (self 
			buildLabelFrom: aStringOrMorph 
			withAction: anActionMorph).
	self updatePageIndex: anInteger.
! !

!LazyTabGroupMorph methodsFor: 'private' stamp: 'AndreiChis 10/12/2014 21:35'!
updatePageIndex: index
	"Change to the given page index, update the toolbar and send the announcement"

	| p oldPage |
	
	index = 0 ifTrue: [^ self].
	oldPage := self tabSelectorMorph selectedTab.
	p := self pageMorph.
	p isNil
		ifTrue: [self contentMorph addMorph: (self pageAt: index)]
		ifFalse: [self contentMorph replaceSubmorph: p by: (self pageAt: index)].
		
	((self pages at: index) toolbar notNil and: [(self pages at: index) toolbar hasSubmorphs])
		ifTrue: [
			self toolbarMorph hasSubmorphs
				ifFalse: [self toolbarMorph addMorph: (self pages at: index) toolbar ]
				ifTrue: [self toolbarMorph 
								replaceSubmorph: self toolbarMorph submorphs first 
								by: (self pages at: index) toolbar ]]
		ifFalse: [self toolbarMorph removeAllMorphs ].
		
	self headerMorph layoutChanged.
	self pageMorph layoutChanged.
	self adoptPaneColor: (self owner ifNil: [self]) paneColor.
	(self tabSelectorMorph tabs at: index) font:  self tabSelectorMorph font.
	self announcer announce: (LazyTabPageChanged new tabs: self; page: (self pages at: index); oldPage: oldPage; pageIndex: index)! !

RubTextFieldMorph subclass: #GLMRubricTextFieldMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMRubricTextFieldMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/8/2014 01:47'!
container: aMorph

	self textArea container: aMorph.! !

!GLMRubricTextFieldMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/7/2014 21:31'!
font: aFont

	self textArea font: aFont! !

!GLMRubricTextFieldMorph methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/7/2014 21:14'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?" 

	^ false! !

!GLMRubricTextFieldMorph methodsFor: 'initialize-release' stamp: 'AliakseiSyrel 10/7/2014 21:25'!
newScrollPane
	| sp |
	sp := GLMRubricTextFieldScrollPane new.
	sp scrollTarget: self defaultScrollTarget.
	^ sp! !

!GLMRubricTextFieldMorph methodsFor: 'initialize-release' stamp: 'AliakseiSyrel 10/7/2014 21:02'!
textAreaClass
	^ GLMRubricTextFieldArea! !

!GLMRubricTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/7/2014 22:14'!
whenGotForcus: anAnnouncement
	super whenGotForcus: anAnnouncement.
	
	self color: Smalltalk ui theme backgroundColor.! !

!GLMRubricTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/7/2014 22:14'!
whenLostForcus: anAnnouncement
	super whenLostForcus: anAnnouncement.
	
	self color: Color transparent.! !

!PluggableListMorph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 15:56'!
setOptimalResizing
	self hResizing: #rigid.
	self vResizing: #rigid! !

!TextMorph methodsFor: '*glamour-morphic-widgets' stamp: 'TudorGirba 1/16/2014 11:45'!
asReadOnlyMorph
	^ StringMorph contents: self text! !

!TextMorph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 16:01'!
setOptimalResizing
	self hResizing: #rigid.
	self vResizing: #rigid! !

!ImageMorph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 16:02'!
setOptimalResizing
	self hResizing: #rigid.
	self vResizing: #rigid! !

Announcement subclass: #GLMActionAnnouncement
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMActionAnnouncement class methodsFor: 'instance creation' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	^self new action: anAction; yourself! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action
	^action! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	action := anAction! !

GLMActionAnnouncement subclass: #GLMKeyStroke
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

GLMActionAnnouncement subclass: #GLMMenuInvoked
	instanceVariableNames: 'menuMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMMenuInvoked class methodsFor: 'as yet unclassified' stamp: 'jre 7/31/2009 15:24'!
action: anAction on: aMenuMorph 
	^self new initializeAction: anAction on: aMenuMorph! !

!GLMMenuInvoked methodsFor: 'initialization' stamp: 'jre 7/31/2009 15:43'!
initializeAction: anAction on: aMenuMorph 
	self action: anAction.
	menuMorph := aMenuMorph! !

!GLMMenuInvoked methodsFor: 'accessing' stamp: 'jre 7/31/2009 15:43'!
menuMorph
	^menuMorph! !

GLMActionAnnouncement subclass: #GLMMenuItemSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

Announcement subclass: #GLMDropDownListMorphSelectionChanged
	instanceVariableNames: 'selectionIndex selectionValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2013 22:26'!
selectionIndex
	^ selectionIndex! !

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2013 22:26'!
selectionIndex: anInteger
	selectionIndex := anInteger! !

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 20:15'!
selectionValue
	^ selectionValue! !

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 20:15'!
selectionValue: anObject
	selectionValue := anObject! !

Announcement subclass: #GLMSelectedTextChanged
	instanceVariableNames: 'start end selectedText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
end
	^ end! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
end: anObject
	end := anObject! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'TudorGirba 7/14/2011 21:49'!
interval
	^ self start to: self end! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
selectedText
	^ selectedText! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
selectedText: anObject
	selectedText := anObject! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
start
	^ start! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
start: anObject
	start := anObject! !

Announcement subclass: #GLMTextChanged
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMTextChanged methodsFor: 'accessing' stamp: 'TudorGirba 7/29/2012 08:33'!
text
	^ text! !

!GLMTextChanged methodsFor: 'accessing' stamp: 'TudorGirba 7/29/2012 08:33'!
text: anObject
	text := anObject! !

Announcement subclass: #GLMTreeMorphSelectionChanged
	instanceVariableNames: 'selectionValue selectionPathValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:56'!
selectionPathValue
	^ selectionPathValue! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:56'!
selectionPathValue: anObject
	selectionPathValue := anObject! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:54'!
selectionValue
	^ selectionValue! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:54'!
selectionValue: anObject
	selectionValue := anObject! !

Announcement subclass: #GLMTreeMorphStrongSelectionChanged
	instanceVariableNames: 'strongSelectionValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMTreeMorphStrongSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:58'!
strongSelectionValue
	^ strongSelectionValue! !

!GLMTreeMorphStrongSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:58'!
strongSelectionValue: anObject
	strongSelectionValue := anObject! !

Announcement subclass: #LazyTabPageAnnouncement
	instanceVariableNames: 'page tabs pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
page
	^ page! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
page: anObject
	page := anObject! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/23/2011 00:23'!
pageIndex
	^ pageIndex! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/23/2011 00:23'!
pageIndex: anObject
	pageIndex := anObject! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
tabs
	^ tabs! !

!LazyTabPageAnnouncement methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
tabs: anObject
	tabs := anObject! !

LazyTabPageAnnouncement subclass: #LazyTabPageChanged
	instanceVariableNames: 'oldPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!LazyTabPageChanged methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
oldPage
	^ oldPage! !

!LazyTabPageChanged methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 23:07'!
oldPage: anObject
	oldPage := anObject! !

LazyTabPageAnnouncement subclass: #LazyTabPageRemoved
	instanceVariableNames: 'newIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!LazyTabPageRemoved methodsFor: 'accessing' stamp: 'TudorGirba 7/23/2011 20:20'!
newIndex
	^ newIndex! !

!LazyTabPageRemoved methodsFor: 'accessing' stamp: 'TudorGirba 7/23/2011 20:33'!
newIndex: anObject
	newIndex := anObject! !

BorderedMorph subclass: #GLMPaneScroller
	instanceVariableNames: 'sizing transform scrollBar paneCount maxPanes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:43'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: ''!
adoptPaneColor: aColor
	super adoptPaneColor: aColor.
	scrollBar adoptPaneColor: aColor! !

!GLMPaneScroller methodsFor: 'private' stamp: 'jorge.ressia 5/25/2009 16:25'!
basicUpdateSizing
	sizing := (self paneCount min: self maxPanes) max: 1! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
bounds: aRectangle
	super bounds: aRectangle.
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
computeMorphWidths
	| paneWidths widths |
	paneWidths := self paneWidthsToFit: self totalPaneWidth.
	widths := OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideOrShowScrollBar
	self isScrollable ifTrue: [self showScrollBar] ifFalse: [self hideScrollBar]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideScrollBar
	self removeMorph: scrollBar.
	self adjustPaneHeight.! !

!GLMPaneScroller methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 23:52'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color transparent! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'TudorGirba 11/30/2012 14:26'!
initialize
	super initialize.
	self 
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
	paneCount := 0.
	maxPanes := 2.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'TudorGirba 2/17/2012 07:47'!
initializeScrollbar
	scrollBar := ScrollBar new 
		model: self;
		setValueSelector: #scrollBarValue:;
		yourself.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self resizeScrollBar.
! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'david_roethlisberger 3/18/2009 14:26'!
initializeTransform
	transform := TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
innerBounds
	| rect |
	rect := super innerBounds.
	^ self scrollBarIsVisible
		ifTrue: [rect withHeight: rect height - self scrollBarHeight - 1]
		ifFalse: [rect]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
isScrollable
	^ self leftoverScrollRange > 0! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
layoutPanes
	| widths rect |
	widths := self computeMorphWidths.
	rect := 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect := rect withWidth: w.
						m bounds: rect.
						rect := rect translateBy: (w@0)]
						
! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
layoutWidgets
	| inner outer |
	outer := super innerBounds.
	inner := self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom)
						corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!GLMPaneScroller methodsFor: 'configuration' stamp: 'TudorGirba 1/26/2011 07:14'!
maxPanes
	^ maxPanes! !

!GLMPaneScroller methodsFor: 'configuration' stamp: 'TudorGirba 1/26/2011 07:14'!
maxPanes: anInteger
	maxPanes := anInteger! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'jorge.ressia 5/25/2009 16:18'!
paneCount
	^ paneCount! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneHeight
	^ transform bounds height! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneWidthsToFit: limit
	| padded |
	padded := Array new: self paneCount.
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!GLMPaneScroller methodsFor: 'panes' stamp: 'tg 8/22/2010 22:40'!
popAndReplacePane: aMorph	
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.	
	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
popPane
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.
	self updatePanes.! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
pushPane: aMorph	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
resizeScrollBar
	| inner outer |
	outer := super innerBounds.
	inner := outer withHeight: outer height - self scrollBarHeight.
	scrollBar bounds: ((inner left @ inner bottom) corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'VincentBlondeau 2/14/2014 17:20'!
scrollBarHeight
	^ self theme scrollbarThickness! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollBarIsVisible
	^ submorphs includes: scrollBar! !

!GLMPaneScroller methodsFor: 'input events' stamp: ''!
scrollBarMenuButtonPressed: anObject! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollDeltaWidth
	^ 1! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'TudorGirba 2/17/2012 07:48'!
scrollToRight
"	(transform submorphs size + 1) / 2 > paneCount ifTrue: [ 
"		scrollBar glmAnimateValue: 1.0 duration: 200 "]"! !

!GLMPaneScroller methodsFor: 'panes' stamp: 'TudorGirba 3/3/2013 21:42'!
separator
	^ "BorderedSubpaneDividerMorph new 
		vertical;
		adoptPaneColor: self paneColor;
		yourself"
		
	GLMMorphic emptyMorph! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'TudorGirba 5/20/2013 06:37'!
separatorWidth
	^ 20! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range := self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval := ((self innerBounds width) / self totalScrollRange) asFloat.
	value := (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
showScrollBar
	self scrollBarIsVisible ifTrue: [^ self].
	self resizeScrollBar.
	self addMorphFront: scrollBar.
	self adjustPaneHeight.
	! !

!GLMPaneScroller methodsFor: 'accessing' stamp: 'david_roethlisberger 3/18/2009 14:27'!
sizing
	^ sizing ifNil: [self updateSizing]! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'jorge.ressia 5/25/2009 16:40'!
updatePanes
	self basicUpdateSizing.
	self layoutPanes.
	self hideOrShowScrollBar.
	self setScrollDeltas.
	self scrollToRight! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
updateSizing
	| old |
	old := sizing.
	self basicUpdateSizing.
	sizing = old ifFalse: [self layoutPanes].
	^sizing! !

BorderedMorph subclass: #LazyTabPage
	instanceVariableNames: 'actualPageMorph labelMorph lazyPageMorphCreation toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2011 00:56'!
actualPageMorph
	^ actualPageMorph ifNil: 
		[actualPageMorph := 
			self lazyPageMorphCreation value
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				yourself]! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
actualPageMorph: anObject
	actualPageMorph := anObject! !

!LazyTabPage methodsFor: 'testing' stamp: 'TudorGirba 1/22/2011 22:26'!
isRendered
	^ actualPageMorph notNil! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
labelMorph
	^ labelMorph! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 17:49'!
labelMorph: anObject
	labelMorph := anObject! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 18:11'!
lazyPageMorphCreation
	^ lazyPageMorphCreation! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 18:11'!
lazyPageMorphCreation: anObject
	lazyPageMorphCreation := anObject! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 20:50'!
toolbar
	^ toolbar! !

!LazyTabPage methodsFor: 'accessing' stamp: 'TudorGirba 1/22/2011 20:50'!
toolbar: anObject
	toolbar := anObject! !

RubNotificationStrategy subclass: #GLMPopperNotificationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMPopperNotificationStrategy commentStamp: 'AndreiChis 10/1/2014 13:35' prior: 0!
I opened a new popper window that displays the given notification. (I do not alter the content of the text editor.)!

!GLMPopperNotificationStrategy methodsFor: 'as yet unclassified' stamp: 'AndreiChis 10/1/2014 11:56'!
notify: aString at: anInteger in: aStream
	| pos |
	pos := self editor selectionInterval notEmpty
		ifTrue: [self editor startIndex + anInteger - 1 ]
		ifFalse: [anInteger].
	self editor selectFrom: pos to: pos.
	
	GLMErrorPopper installAlarmFor: [ 
		(GLMErrorPopper new withString: aString from: self editor textArea owner owner owner)
			openInWorld ]! !

!MorphTreeMorph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 15:56'!
setOptimalResizing
	self hResizing: #rigid.
	self vResizing: #rigid! !

MorphTreeNodeModel subclass: #GLMExpanderContentsNodeModel
	instanceVariableNames: 'containerNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMExpanderContentsNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 16:49'!
containerNode
	^ containerNode! !

!GLMExpanderContentsNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 16:49'!
containerNode: anObject
	containerNode := anObject! !

!GLMExpanderContentsNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 2/15/2011 12:25'!
elementColumn
	| row morph |
	
	morph := GLMMorphicPaneWithoutTitleRenderer new render: self containerNode item.
	morph 
		borderStyle: (UITheme current buttonSelectedBorderStyleFor: morph).

	row := OrderedCollection with: morph.
	^ UITheme current newRowIn: World for: row! !

!GLMExpanderContentsNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 14:09'!
icon
	^ nil! !

MorphTreeNodeModel subclass: #GLMExpanderLabelNodeModel
	instanceVariableNames: 'containerTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMExpanderLabelNodeModel class methodsFor: 'instance creation' stamp: 'TudorGirba 1/2/2011 21:16'!
with: anObject in: aTreeModel
	^ (self with: anObject) containerTree: aTreeModel; yourself! !

!GLMExpanderLabelNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 1/5/2011 17:24'!
childrenItems
	^ OrderedCollection 
		with: ((GLMExpanderContentsNodeModel with: (self->self item)) containerNode: self)! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 13:53'!
containerTree
	^ containerTree! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 13:53'!
containerTree: anObject
	containerTree := anObject! !

!GLMExpanderLabelNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 1/5/2011 10:50'!
contents
	^ self childrenItems! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 14:10'!
displayText
	^ UITheme current 
		newTextIn: World
		text: (self item presentations titleValue ifNil: ['noname']) ! !

!GLMExpanderLabelNodeModel methodsFor: 'callbacks' stamp: 'TudorGirba 1/5/2011 23:21'!
elementColumn
	| row tags tagsFilter |
	row := OrderedCollection with: (self displayText).
	
"	tags:= self containerTree glamourPresentation tagsFor: self item to: #show.
	tagsFilter := self containerTree glamourPresentation tagsFor: self item to: #filter.
	tags withIndexDo:[ :each :index | 
			row addLast: (self buttonForTag: each 
									  filter: (tagsFilter at: index ifAbsentPut:[ each ])) ].
"	^ (UITheme current newRowIn: World for: row) fillStyle: Color veryLightGray! !

!GLMExpanderLabelNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 14:20'!
icon
	^ nil! !

MorphTreeNodeModel subclass: #GLMTreeMorphNodeModel
	instanceVariableNames: 'contents containerTree onSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'ewe 11/16/2012 14:32'!
= anObject
	"This is needed to handle the update of the whole list while still preserving the selection"
	^ self species = anObject species and: [ self item = anObject item ]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'DamienCassou 5/11/2011 08:15'!
allContents
	^ self childrenItems
		collect: [ :d | 
			(self class with: d)
				parentNode: self;
				containerTree: self containerTree;
				yourself ]! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'VeronicaUquillas 6/15/2010 11:13'!
buttonForTag: each filter: filter
	| button |

	button := GLMMorphic 
		togglingButtonLabelled: each
		pressed: (self containerTree shouldFilterByTag: filter)
		style: self containerTree glamourPresentation tagsStyle.
	button
		target: self;
		actionSelector: #toggleFilteringByTag:;
		arguments: (Array with: filter).
	^ button! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 4/18/2010 23:19'!
childrenItems
	^ (self containerTree glamourPresentation childrenValueOf: self item atLevel: self path size) ifNil: [OrderedCollection new]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree
	^ containerTree! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree: anObject
	containerTree := anObject! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'DamienCassou 5/11/2011 08:16'!
contents
	^ contents ifNil: [ contents := self allContents select: [ :each | each shouldBeDisplayed ] ]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'usmanbhatti 3/5/2015 12:34'!
displayText
	^ (UITheme current 
		newTextIn: World
		text: (self containerTree glamourPresentation formatedDisplayValueOf: self item))
			backgroundColor: self textBackgroundColor;
			yourself! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'AndreiChis 4/20/2014 22:04'!
elementColumn
	| rowElements |
	
	rowElements := OrderedCollection new
		add: self displayText;
		addAll: (self tagMorphsFrom: self containerTree glamourPresentation);
		yourself.
	
	^ (UITheme current newRowIn: World for: rowElements).! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'alain.plantec 9/8/2009 14:37'!
enabled
	^ true! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/16/2009 23:39'!
executeMenuAction: anAction
	self containerTree announce: (GLMMenuItemSelected action: anAction)! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 2/27/2014 06:17'!
expandParentPath
"	self openItemPath: anArray"
	self containerTree expandNodePath: self path! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'usmanbhatti 3/10/2015 16:25'!
filterAllNodes
	self withContentsDo: 
		[ :node | 
		self flag: 'this should be delegated to the presentation
		and glamourValue should be used to include the entity ports'.
		(self containerTree glamourPresentation filterStrategy 
			value: self containerTree inputText asString
			value: node item) == true ifTrue: [ ^ true ] ].
	^ false
	! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'usmanbhatti 3/10/2015 16:27'!
filterRootsOnly
	(self containerTree glamourPresentation filterStrategy value: self containerTree inputText asString value: self item)	== true
		ifTrue: [ ^ true ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2013 13:46'!
helpText
	^ nil! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:54'!
icon
	^ self containerTree glamourPresentation iconFor: self item! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/8/2009 21:09'!
keyStroke: aCharacter from: aTreeMorph 
	^ false
! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'EstebanLorenzano 4/20/2012 16:18'!
menu: aMenuMorph shifted: b 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self containerTree allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		(targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action)
			icon:  action icon;
			keyText: (action hasShortcut 
				ifTrue: [ action shortcutAsString ]
				ifFalse: [ nil ]) ].
	^ aMenuMorph! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode
	^ parentNode! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode: aNode
	parentNode := aNode
	! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 4/15/2010 00:24'!
path
	"returns the list of nodes to the root"
	^ self pathIn: OrderedCollection new.! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/10/2009 12:44'!
pathIn: aCollection 
	self parentNode ifNotNil: [
		(aCollection includes: self parentNode)
			ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

!GLMTreeMorphNodeModel methodsFor: 'printing' stamp: 'tg 9/9/2009 13:30'!
printOn: aStream
	aStream nextPutAll: 'a NodeModel with '.
	aStream nextPutAll: self item printString.! !

!GLMTreeMorphNodeModel methodsFor: 'actions' stamp: 'DamienCassou 5/11/2011 07:55'!
resetContents
	contents := nil! !

!GLMTreeMorphNodeModel methodsFor: 'actions' stamp: 'DamienCassou 5/11/2011 08:17'!
resetContentsRecursively 
	self resetContents.
	self allContents do: [:each | each resetContentsRecursively]! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'AndreiChis 12/5/2014 00:02'!
rowMorphForColumn: aGlamourColumn
	| rowElements contentMorph tagMorphs |
		
	aGlamourColumn modifiedBlock
		ifNil: [
			contentMorph := (self containerTree glamourPresentation 
			column: aGlamourColumn
			valueFor: self item) asMorph asReadOnlyMorph ]
		ifNotNil: [
			contentMorph := self textFieldMorphFor: nil.
			contentMorph setText: (
				self containerTree glamourPresentation 
					column: aGlamourColumn 
					valueFor: self item) asString.
			contentMorph hResizing: #rigid.
			contentMorph width: contentMorph textArea width.
			contentMorph announcer when: RubReturnEntered do: [ :ann |
				 aGlamourColumn modifiedBlock cull: contentMorph text cull: self item cull: self containerTree glamourPresentation ] ].
	
	tagMorphs := self tagMorphsFrom: aGlamourColumn.
	tagMorphs ifEmpty: [ ^ contentMorph ].
	
	rowElements := OrderedCollection new
		add: contentMorph;
		addAll: tagMorphs;
		yourself.			
	^ (UITheme current newRowIn: World for: rowElements)! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/30/2009 02:10'!
shouldBeDisplayed
	^ self shouldBeDisplayedByTags and: [ self shouldBeDisplayedByText ]! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/30/2009 02:15'!
shouldBeDisplayedByTags
	| nodeTags |
	self flag: 'it looks like this method does not really get called for children'.
"	self item mooseName = #'org::easymock' ifTrue: [self haltOnce ].
"	self containerTree tagsToFilterBy isEmpty ifTrue: [ ^ true ].
	self withContentsDo: [ :node | 
		nodeTags := self containerTree glamourPresentation tagsFor: node item to: #filter.
		(self containerTree tagsToFilterBy allSatisfy: [ :each | nodeTags includes: each ])
			ifTrue: [ ^ true ] ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'usmanbhatti 3/10/2015 16:29'!
shouldBeDisplayedByText
	self containerTree shouldFilterByTextInput
		ifFalse: [ ^ true ].
	^ self containerTree glamourPresentation filterRootsOnly
		ifTrue: [ self filterRootsOnly ]
		ifFalse: [ self filterAllNodes ]
	! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'AndreiChis 4/20/2014 22:04'!
tagMorphsFrom: aTagProvider
	| tagMorphs tags tagsFilter |
	tagMorphs := OrderedCollection new.
	tags:= self containerTree glamourPresentation tagsFor: self item fromProvider: aTagProvider to: #show.
	tagsFilter := self containerTree glamourPresentation tagsFor: self item fromProvider: aTagProvider to: #filter.
	tags withIndexDo:[ :each :index | 
			tagMorphs addLast: (self buttonForTag: each 
									  filter: (tagsFilter at: index ifAbsentPut:[ each ])) ].
	^ tagMorphs! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'cyrilledelaunay 7/6/2011 12:50'!
textBackgroundColor
	^ self containerTree glamourPresentation textBackgroundColorFor: self item! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'AndreiChis 10/10/2014 18:23'!
textFieldMorphFor: textModel
	|morph|
	
	morph := GLMRubricTextFieldMorph new
		"getSelectionSelector: #primarySelectionInterval;"
		"model: textModel;"
		"color: Smalltalk ui theme backgroundColor;"
		color: Color transparent;
		editingMode: RubPlainTextMode new;
		textFont: StandardFonts defaultFont;
		yourself.
		
	self flag: 'Temporary solution until Moose moves to Pharo 4'.
	(Smalltalk ui theme class canPerform: #textColor) ifTrue: [ 
		morph textColor: Smalltalk ui theme  textColor ].
	
	^ morph! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:33'!
toggleFilteringByTag: aTag 
	self containerTree toggleFilteringByTag: aTag! !

!GLMTreeMorphNodeModel methodsFor: 'enumerating' stamp: 'tg 9/9/2009 13:42'!
withContentsDo: aBlock
	self flag: 'if the tree is infinite due to recursion, this might not stop'.
	aBlock value: self.
	self contents do: [:each | each withContentsDo: aBlock ]! !

MorphTreeModel subclass: #GLMExpanderTreeMorphModel
	instanceVariableNames: 'roots glamourExpander'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/2/2011 19:32'!
glamourExpander
	^ glamourExpander! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/2/2011 19:32'!
glamourExpander: anObject
	glamourExpander := anObject! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/4/2011 15:06'!
nodeModelFor: anObject
	^ GLMExpanderLabelNodeModel with: anObject in: self! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 14:07'!
roots
"	| filtered |"
	roots ifNil: [ self roots: self glamourExpander panes ].
	^ roots
"	filtered := roots select: [ :each | each shouldBeDisplayed ].
	((self shouldFilterByAmount and: [
		self amountToFilterBy < filtered size]) and: [
			filtered notEmpty]) ifTrue: [
		filtered := filtered first: self amountToFilterBy ].
	^ filtered"! !

!GLMExpanderTreeMorphModel methodsFor: 'accessing' stamp: 'TudorGirba 1/3/2011 13:52'!
roots: anObjectOrCollection
	roots := anObjectOrCollection isCollection 
		ifTrue: [ anObjectOrCollection collect: [:each | self nodeModelFor: each ] ]
		ifFalse: [ OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

RubTextScrollPane subclass: #GLMRubricTextFieldScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMRubricTextFieldScrollPane methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/7/2014 21:22'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?." 

	^ false! !

TextMorphForEditView subclass: #GLMTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMTextMorphForEditView commentStamp: 'TudorGirba 7/14/2011 09:44' prior: 0!
GLMTextMorphForEditView is meant to work with GLMPluggableTextMorph.!

!GLMTextMorphForEditView methodsFor: 'editing' stamp: 'VincentBlondeau 2/4/2014 15:48'!
acceptContents
	self flag: 'Hack for disable the CTRL+S behaviour'! !

!GLMTextMorphForEditView methodsFor: 'private' stamp: 'TudorGirba 7/14/2011 21:37'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^GLMSmalltalkEditor! !

!GLMTextMorphForEditView methodsFor: 'callbacks' stamp: 'TudorGirba 7/14/2011 11:10'!
keyStroke: anEvent
	| isHandledByModel |
	isHandledByModel := self editView model keystroke: anEvent from: self editView.
	isHandledByModel ifFalse: [ super keyStroke: anEvent ]! !

!MorphTreeNodeMorph methodsFor: '*Glamour-Morphic-Widgets' stamp: 'AliakseiSyrel 10/8/2014 02:11'!
container

	^ container! !

!SimpleButtonMorph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 16:01'!
setOptimalResizing
	self hResizing: #rigid.
	self vResizing: #rigid! !

!ScrollBar methodsFor: '*glamour-morphic-widgets' stamp: 'TudorGirba 1/16/2011 13:10'!
glmAnimateValue: aNumber duration: anInteger
"	aNumber = value ifTrue: [^ self ]."
	anInteger <= 0 
		ifTrue: [ self setValue: aNumber ]
		ifFalse: [
			| startTime start end |
			startTime := Time millisecondClockValue.
			start := value "roundTo: scrollDelta".
			[ | delta |
			[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
				self setValue: (aNumber - start) * (delta / anInteger) + start.
				Processor yield ].
				self setValue: aNumber ]
					fork ]! !

!ScrollBar methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 15:58'!
setOptimalResizing
	self hResizing: #rigid.
	self vResizing: #rigid! !

Announcer subclass: #GLMMorphicModel
	instanceVariableNames: 'glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

GLMMorphicModel subclass: #GLMButtonModel
	instanceVariableNames: 'glamourAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:25'!
buttonLabel
	^ self glamourAction title! !

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:35'!
execute
	self glamourAction actOn: self glamourPresentation! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction
	^ glamourAction! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction: anObject
	glamourAction := anObject! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'TudorGirba 11/25/2010 13:20'!
allKeystrokeActions
	^ (self glamourPresentation allActions, self glamourPresentation allSelectionActions) select: [ :action | 
		action hasShortcut ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 11/19/2010 18:18'!
allMenuActions
	^ self glamourPresentation allSelectionActions select: [:action | action hasTitle ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'jre 7/31/2009 09:48'!
executeMenuAction: anAction
	self announce: (GLMMenuItemSelected action: anAction)! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation
	^ glamourPresentation! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMMorphicModel methodsFor: 'initialization' stamp: 'tg 8/4/2009 15:26'!
initialize
	super initialize.! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'TudorGirba 3/24/2013 12:56'!
keystroke: anEvent from: aMorph
	| action |

	action := self allKeystrokeActions detect: [:a | a shortcut = anEvent keyCharacter] ifNone: [nil].
	action ifNotNil: [ 
		self announce: (GLMKeyStroke action: action).
		^ true ].
	^ false! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'AndreiChis 10/5/2014 15:22'!
menu: aMenuMorph 
	| subMenus targetMenuMorph subMenu allActions |
	subMenus := Dictionary new.
	allActions := self allMenuActions.
	allActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		(action separatorBefore and: [ allActions first ~= action ]) ifTrue: [ targetMenuMorph addLine ].
		(targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action)
			icon:  action icon;
			keyText: (action hasShortcut 
				ifTrue: [ action shortcutAsString ]
				ifFalse: [ nil ]).
		(action separatorAfter and: [ allActions last ~= action ]) ifTrue: [ targetMenuMorph addLine ] ].
	^ aMenuMorph! !

GLMMorphicModel subclass: #GLMRubricTextModel
	instanceVariableNames: 'announcer primarySelectionInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

GLMRubricTextModel subclass: #GLMRubricSmalltalkTextModel
	instanceVariableNames: 'highlightSmalltalk highlightSmalltalkContext bindingsStrategy variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/3/2014 19:17'!
appendVariableBinding: anAssociationList

	anAssociationList ifNotNil: [
		anAssociationList do: [ :anAssociation | 
			self variableBindings at: anAssociation key put: anAssociation value ] ]! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/7/2014 17:47'!
bindingOf: aSymbol

	^ self bindingsStrategy cull: self variableBindings cull: aSymbol! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/7/2014 17:29'!
bindingsStrategy

	^ bindingsStrategy! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/3/2014 18:15'!
bindingsStrategy: aBlock

	bindingsStrategy := aBlock! !

!GLMRubricSmalltalkTextModel methodsFor: 'accessing' stamp: 'AndreiChis 5/7/2014 17:17'!
doItContext
	^ self glamourPresentation doItContext ! !

!GLMRubricSmalltalkTextModel methodsFor: 'accessing' stamp: 'AndreiChis 5/7/2014 17:17'!
doItReceiver
	^ self glamourPresentation doItReceiver ! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/3/2014 18:17'!
guessTypeForName: aString 
	^ nil! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/3/2014 19:24'!
hasBindingOf: aSymbol

	^ self variableBindings includesKey: aSymbol! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/3/2014 18:16'!
hasBindingThatBeginsWith: aString
	^ self variableBindings keys anySatisfy: [:each | each beginsWith: aString]! !

!GLMRubricSmalltalkTextModel methodsFor: 'shout' stamp: 'AndreiChis 4/21/2014 19:04'!
highlightSmalltalk
	^ highlightSmalltalk! !

!GLMRubricSmalltalkTextModel methodsFor: 'shout' stamp: 'AndreiChis 4/21/2014 19:05'!
highlightSmalltalk: aBoolean
	highlightSmalltalk := aBoolean! !

!GLMRubricSmalltalkTextModel methodsFor: 'shout' stamp: 'AndreiChis 4/21/2014 19:05'!
highlightSmalltalkContext
	^ highlightSmalltalkContext! !

!GLMRubricSmalltalkTextModel methodsFor: 'shout' stamp: 'AndreiChis 4/21/2014 19:05'!
highlightSmalltalkContext: aClassOrMetaclass
	highlightSmalltalkContext := aClassOrMetaclass! !

!GLMRubricSmalltalkTextModel methodsFor: 'testing' stamp: 'AndreiChis 5/3/2014 18:17'!
isCodeCompletionAllowed 
	^true! !

!GLMRubricSmalltalkTextModel methodsFor: 'accessing' stamp: 'AndreiChis 5/21/2014 10:36'!
selectedBehavior
	
	^ self highlightSmalltalkContext! !

!GLMRubricSmalltalkTextModel methodsFor: 'accessing' stamp: 'AndreiChis 5/30/2014 13:57'!
selectedClassOrMetaClass
	
	^ self selectedBehavior! !

!GLMRubricSmalltalkTextModel methodsFor: 'shout' stamp: 'AndreiChis 4/21/2014 19:04'!
shoutAboutToStyle: aPluggableShoutMorph
	self highlightSmalltalk ifFalse: [^ false].
	self highlightSmalltalkContext ifNotNil: [ :classOrMetaClass |
 		aPluggableShoutMorph classOrMetaClass: classOrMetaClass  ].
	^ true! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/3/2014 18:15'!
variableBindings
	^ variableBindings ifNil: [variableBindings := Dictionary new]! !

!GLMRubricSmalltalkTextModel methodsFor: 'bindings' stamp: 'AndreiChis 5/3/2014 18:16'!
variableBindings: aDictionary
	variableBindings := aDictionary! !

!GLMRubricTextModel methodsFor: 'accessing' stamp: 'TudorGirba 6/2/2013 22:03'!
announcer
	^ announcer ifNil: [ announcer := Announcer new weak ]! !

!GLMRubricTextModel methodsFor: 'accessing' stamp: 'TudorGirba 6/2/2013 22:03'!
announcer: anObject
	announcer := anObject! !

!GLMRubricTextModel methodsFor: 'accessing' stamp: 'TudorGirba 2/8/2014 23:32'!
getText
	^ self glamourPresentation formatedDisplayValue! !

!GLMRubricTextModel methodsFor: 'callbacks' stamp: 'AndreiChis 5/21/2014 09:50'!
menu

	^ self menu: MenuMorph new! !

!GLMRubricTextModel methodsFor: 'accessing' stamp: 'AlainPlantec 9/18/2013 21:56'!
primarySelectionInterval
	^ primarySelectionInterval! !

!GLMRubricTextModel methodsFor: 'accessing' stamp: 'AlainPlantec 9/18/2013 21:57'!
primarySelectionInterval: anInterval 
	primarySelectionInterval := anInterval! !

!GLMRubricTextModel methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 14:47'!
setText: aText from: aRubScrolledTextMorph 
	self glamourPresentation text: aText.
	^true! !

GLMMorphicModel subclass: #GLMTextModel
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

GLMTextModel subclass: #GLMSmalltalkCodeModel
	instanceVariableNames: 'highlightSmalltalk highlightSmalltalkContext variableBindings bindingsStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
addVariableBinding: anAssociation
	self variableBindings at: anAssociation key put: anAssociation value! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'VincentBlondeau 3/19/2014 11:54'!
bindingOf: aSymbol
	^ self bindingsStrategy cull: self variableBindings cull: aSymbol! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'AndreiChis 3/6/2014 12:17'!
bindingsStrategy

	^ bindingsStrategy ifNil: [ bindingsStrategy := self defaultBindingsStrategy ]! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'AndreiChis 3/6/2014 12:16'!
bindingsStrategy: aBlock

	bindingsStrategy := aBlock! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'AndreiChis 3/6/2014 12:17'!
defaultBindingsStrategy

	^ [ :currentBindings :aSymbol |
		 currentBindings associationAt: aSymbol ifAbsent: [nil] ]! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/13/2013 15:40'!
doItContext
	^ self glamourPresentation doItContext ! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
doItReceiver
	^ self glamourPresentation doItReceiver ! !

!GLMSmalltalkCodeModel methodsFor: 'completion' stamp: 'TudorGirba 9/20/2011 23:33'!
guessTypeForName: aString 
	^ nil! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
hasBindingOf: aSymbol
	^ self variableBindings includesKey: aSymbol! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
hasBindingThatBeginsWith: aString
	^ self variableBindings keys anySatisfy: [:each | each beginsWith: aString]! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
highlightSmalltalk
	^ highlightSmalltalk! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
highlightSmalltalk: anObject
	highlightSmalltalk := anObject! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
highlightSmalltalkContext
	^ highlightSmalltalkContext! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
highlightSmalltalkContext: anObject
	highlightSmalltalkContext := anObject! !

!GLMSmalltalkCodeModel methodsFor: 'completion' stamp: 'EstebanLorenzano 4/18/2012 09:57'!
isCodeCompletionAllowed 
	^true! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
selectedClassOrMetaClass
	^ self highlightSmalltalkContext! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
shoutAboutToStyle: aPluggableShoutMorph
	self highlightSmalltalk ifFalse: [^ false].
	self highlightSmalltalkContext notNil ifTrue: [
		aPluggableShoutMorph classOrMetaClass: self highlightSmalltalkContext].
	^ true! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
variableBindings
	^ variableBindings ifNil: [variableBindings := Dictionary new]! !

!GLMSmalltalkCodeModel methodsFor: 'accessing' stamp: 'TudorGirba 9/20/2011 23:33'!
variableBindings: anObject
	variableBindings := anObject! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'TudorGirba 2/14/2012 08:42'!
accept: aText notifying: anObject 
	aText asString trimBoth ifEmpty: [^self].
	self text: aText.
	self changed: #text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'TudorGirba 2/9/2014 00:13'!
changedText: aTextOrString
	text := aTextOrString.
	self changed: #text! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'TudorGirba 3/24/2013 12:56'!
keystroke: anEvent from: aMorph
	anEvent anyModifierKeyPressed ifTrue: [ ^ super keystroke: anEvent from: aMorph ].
	self glamourPresentation text: self text.
	^ false! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:31'!
menu: aMorphMenu shifted: b
	^ self menu: aMorphMenu! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 5/14/2009 22:10'!
selectSilently: anIndex
	self changed: #selection! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/22/2010 13:14'!
selection
	^ self glamourPresentation selectionInterval ifNil: [1 to: 0]! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
text
	^text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'TudorGirba 2/9/2014 00:04'!
text: aTextOrString
	text := aTextOrString.
	self glamourPresentation ifNotNil: [ :presentation | presentation text: text ]! !

SystemWindow subclass: #GLMWatcherWindow
	instanceVariableNames: 'isOpen contentsMorph process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

GLMWatcherWindow class
	instanceVariableNames: 'uniqueInstance'!

!GLMWatcherWindow commentStamp: '<historical>' prior: 0!
This morph is used as support for the watcher (quick preview) behavior.

GLMWatcherWindow uniqueInstance openInWorld.
GLMWatcherWindow reset.!

GLMWatcherWindow class
	instanceVariableNames: 'uniqueInstance'!

!GLMWatcherWindow class methodsFor: 'instance creation' stamp: 'TudorGirba 11/16/2013 13:46'!
buildKeymapsOn: aBuilder
	<keymap>
	
	(aBuilder shortcut: #openGlamourWatcher) 
		category: #Glamour
		default: Character space command shift 
		do: [ :morph | self uniqueInstance toggleOpen ].

	aBuilder attachShortcutCategory: #Glamour to: Morph.! !

!GLMWatcherWindow class methodsFor: 'instance creation' stamp: 'TudorGirba 5/12/2012 22:50'!
reset 
	"self reset"
	uniqueInstance := nil! !

!GLMWatcherWindow class methodsFor: 'instance creation' stamp: 'TudorGirba 5/12/2012 22:52'!
uniqueInstance 
	^ uniqueInstance ifNil: [uniqueInstance := self new]! !

!GLMWatcherWindow methodsFor: 'settings' stamp: 'TudorGirba 11/27/2014 15:36'!
activeFillStyle
	"Return the active fillStyle for the receiver."

	^ self theme watcherWindowActiveFillStyleFor: self! !

!GLMWatcherWindow methodsFor: 'settings' stamp: 'TudorGirba 5/20/2012 22:51'!
activeTitleFillStyle
	"Return the active title fillStyle for the receiver."
	
	^ SolidFillStyle color: Color transparent! !

!GLMWatcherWindow methodsFor: 'accessing' stamp: 'TudorGirba 5/27/2012 23:20'!
addContent: aBlockWhoseValueReturnsAMorph
	| newMorph |

	"if we are still rendering some contents for another watcher,
	we stop and replace with the current request"
	process ifNotNil: [ process terminate ].
	process := nil.
	
	process := [
		newMorph := aBlockWhoseValueReturnsAMorph value.
		WorldState addDeferredUIMessage:  [
			self contentsMorph
				removeAllMorphs;
				addMorph: newMorph fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))	
		]
	] newProcess. 
	process priority: Processor userBackgroundPriority.
	process resume! !

!GLMWatcherWindow methodsFor: 'initialize' stamp: 'TudorGirba 5/20/2012 16:40'!
addContentsMorph
	self contentsMorph: GLMMorphic emptyMorph.
	self contentsMorph
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (10@10 corner: -10@(-10)));
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	self addMorphBack: self contentsMorph! !

!GLMWatcherWindow methodsFor: 'accessing' stamp: 'TudorGirba 5/20/2012 01:32'!
contentsMorph
	^ contentsMorph! !

!GLMWatcherWindow methodsFor: 'accessing' stamp: 'TudorGirba 5/20/2012 01:32'!
contentsMorph: anObject
	contentsMorph := anObject! !

!GLMWatcherWindow methodsFor: 'settings' stamp: 'TudorGirba 5/31/2012 23:24'!
defaultBorderStyle
	^ FillStyleBorder color: (Color white darker alpha: 0.5) width: 10! !

!GLMWatcherWindow methodsFor: 'initialize' stamp: 'TudorGirba 5/20/2012 10:48'!
defaultFillStyle
	^ SolidFillStyle color: Color transparent! !

!GLMWatcherWindow methodsFor: 'open/close' stamp: 'TudorGirba 5/12/2012 23:11'!
delete 
	super delete. 
	isOpen := false! !

!GLMWatcherWindow methodsFor: 'initialize' stamp: 'TudorGirba 5/20/2012 11:00'!
fastFramingOn

	^self theme settings fastDragging and: [self isFlexed not]! !

!GLMWatcherWindow methodsFor: 'settings' stamp: 'TudorGirba 5/23/2012 14:11'!
inactiveFillStyle
	"Return the active title fillStyle for the receiver."
	
	^ self theme watcherWindowInactiveFillStyleFor: self! !

!GLMWatcherWindow methodsFor: 'settings' stamp: 'TudorGirba 5/20/2012 23:29'!
inactiveTitleFillStyle
	"Return the active title fillStyle for the receiver."
	
	^ SolidFillStyle color: Color transparent! !

!GLMWatcherWindow methodsFor: 'initialize' stamp: 'TudorGirba 5/27/2012 01:41'!
initialize
	super initialize.
	self fillStyle: self defaultFillStyle.
"	self borderStyle: self defaultBorderStyle."
	isOpen := false.
	self setLabel: 'Glamorous Watcher'.
	self addCornerGrips.
	self addEdgeGrips.
	self addContentsMorph.
	process := nil.
	self
		on: Character escape
		do: [ self hide ]! !

!GLMWatcherWindow methodsFor: 'accessing' stamp: 'TudorGirba 5/19/2012 18:05'!
morphicLayerNumber
	"We want this preview to be always on top"
	
	^ 10! !

!GLMWatcherWindow methodsFor: 'open/close' stamp: 'TudorGirba 5/19/2012 18:01'!
openInWorld
	super openInWorld.
	isOpen := true.
! !

!GLMWatcherWindow methodsFor: 'initialize' stamp: 'TudorGirba 5/23/2012 13:59'!
replaceBoxes
	"Rebuild the various boxes."
	
	labelArea removeAllMorphs.
	self setLabelWidgetAllowance.
	self theme configureWatcherWindowLabelAreaFor: self.
	self setFramesForLabelArea.
	self isActive ifFalse: [labelArea passivate]! !

!GLMWatcherWindow methodsFor: 'settings' stamp: 'TudorGirba 5/23/2012 13:48'!
taskbarTask
	"Answer a new taskbar task for the receiver.
	Answer nil if not required."

	^nil! !

!GLMWatcherWindow methodsFor: 'open/close' stamp: 'TudorGirba 5/14/2013 08:51'!
toggleOpen 
	isOpen ifFalse: [ ^ self openInWorld ].
	self visible 
		ifTrue: [self hide] 
		ifFalse: [self show]! !

!GLMWatcherWindow methodsFor: 'settings' stamp: 'TudorGirba 5/23/2012 13:13'!
wantsExpandBox
	"Answer whether I'd like an expand box"

	^ false! !

Object subclass: #GLMDropListModel
	instanceVariableNames: 'list selectionIndex announcer glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 15:55'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 16:33'!
glamourPresentation

	^glamourPresentation! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 16:33'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'AndreiChis 8/21/2013 16:10'!
list

	^list ifNil: [ list:= (self glamourPresentation displayValue 
									collect:[ :each| (self glamourPresentation formatedDisplayValueOf: each) asMorph ])]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 15:53'!
list: anObject
	list := anObject! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'AndreiChis 8/21/2013 15:42'!
resetData

	list := nil.
	selectionIndex := nil! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/27/2010 17:48'!
selectedItem
	"Answer the currently selected item or nil if none."

	^self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self glamourPresentation displayValue at: self selectionIndex]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/26/2010 14:45'!
selectionIndex

	^ selectionIndex ifNil:[ selectionIndex:= self glamourPresentation selectedIndex ]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2013 22:43'!
selectionIndex: anObject
	selectionIndex := anObject.
	self announcer announce: (
			GLMDropDownListMorphSelectionChanged new 
				selectionValue: self selectedItem;
				selectionIndex: selectionIndex;
				yourself)! !

Object subclass: #GLMMorphic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 6/15/2010 10:33'!
alignmentMorph: aCollectionOfMorphs
	"Answer a row-oriented AlignmentMorph holding the given collection"
	| morph |

	morph:= AlignmentMorph new
		listDirection: #leftToRight;
		borderWidth: 0;
		color: Color transparent;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		layoutInset: 1;
		wrapCentering: #center;
		cellPositioning: #center.
	aCollectionOfMorphs do: [ :each | morph addMorphBack: each].
	^morph! !

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/21/2011 10:11'!
containerMorph
	^ PanelMorph new
		layoutPolicy: ProportionalLayout new;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		yourself! !

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 5/31/2012 22:37'!
emptyMorph
	^ self containerMorph
		fillStyle: (SolidFillStyle color: Color transparent );
		yourself! !

!GLMMorphic class methodsFor: 'button styles' stamp: 'tg 9/23/2010 20:04'!
grayRoundedButtonStyle: button morph: aMorph pressed: aBoolean
	button useRoundedCorners.
	(self isAlignmentMorph: aMorph)
		ifTrue: [
			aBoolean 
				ifTrue: [	aMorph lastSubmorph color: Color gray.
						button fillStyle: (button theme buttonSelectedFillStyleFor: button).
						button borderStyle: (button theme buttonSelectedBorderStyleFor: button) ]
				ifFalse:[	aMorph lastSubmorph color: Color white.
						button fillStyle: (button theme buttonNormalFillStyleFor: button).
						button borderStyle: (button theme buttonNormalBorderStyleFor: button) ] ]
		ifFalse: [			
			aBoolean 
				ifTrue: [	aMorph color: Color gray.
						button color: Color veryLightGray ]
				ifFalse:[	aMorph color: Color white.
						button color: Color lightGray ] ]
! !

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 11/19/2009 20:08'!
isAlignmentMorph: anObject

	^anObject isMemberOf: AlignmentMorph! !

!GLMMorphic class methodsFor: 'button styles' stamp: 'VeronicaUquillas 6/15/2010 10:49'!
isGrayRoundedButton: aSymbol

	^aSymbol = #grayRoundedButton
		or:[ aSymbol = #default ]! !

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 11/19/2009 20:08'!
isImageMorph: anObject

	^anObject isMemberOf: ImageMorph! !

!GLMMorphic class methodsFor: 'button styles' stamp: 'tg 9/3/2010 14:07'!
isWhiteRectangledButton: aSymbol
	^aSymbol = #whiteRectangledButton! !

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 11/1/2013 23:31'!
morphElement: anObject

	anObject isString
	ifTrue:[ ^StringMorph 
					contents: anObject 
					font: (LogicalFont 
						familyName: UITheme current buttonFont familyName
						pointSize: UITheme current buttonFont pointSize - 2) ].
	
	anObject isCollection 
	ifTrue: [ |row|
				row:= OrderedCollection new.
				anObject do: [ :e| row add: (self morphElement: e) ].
				^self alignmentMorph: row ].
				
	anObject isForm
	ifTrue:[ ^ImageMorph new form: anObject ].
	
	^self containerMorph! !

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'tg 9/23/2010 19:59'!
styleButton: button morph: m pressed: aBoolean style: aSymbol
	(self isGrayRoundedButton: aSymbol)
		ifTrue:[ self grayRoundedButtonStyle: button morph: m pressed: aBoolean ].
	
	(self isWhiteRectangledButton: aSymbol)
		ifTrue:[ self whiteRectangledButtonStyle: button morph: m pressed: aBoolean ]! !

!GLMMorphic class methodsFor: 'as yet unclassified' stamp: 'tg 9/23/2010 21:17'!
togglingButtonLabelled: anObject pressed: aBoolean style: aSymbol
	| button oldLabel m |
	button := SimpleButtonMorph new.
	(oldLabel := button findA: StringMorph) ifNotNil: [ oldLabel delete ].
	m := self morphElement: anObject.
	button
		addMorph: m;
		borderColor: Color transparent.
	(self isAlignmentMorph: m)
		ifTrue:[ 
			button extent: (m width + 6 ) @ (m height + 6 ).
			m position: 3 @ 3 ]
		ifFalse:[ 
			(self isImageMorph: m)
				ifTrue: [ button extent: (m width + 6) @ (m height + 6) ]
				ifFalse:[ button extent: (m width + 6) @ (m height + 6) ].
			m position: 3 @ 3.	"button center - (m extent // 2)" ].
	self styleButton: button morph: m pressed: aBoolean style: aSymbol.
	m lock.
	^ button! !

!GLMMorphic class methodsFor: 'button styles' stamp: 'VeronicaUquillas 1/10/2011 17:13'!
whiteRectangledButtonStyle: button morph: aMorph pressed: aBoolean

	button useSquareCorners.
	(self isAlignmentMorph: aMorph)
	ifTrue:[ 
		aBoolean 
		ifTrue: [ aMorph lastSubmorph color: Color white.
				      button borderColor: Color gray.
					button color: Color gray ]
		ifFalse:[ aMorph lastSubmorph color: Color black.
			            button borderColor: Color gray.
					button color: Color white ].
		button extent: aMorph width @ (aMorph height - 2).
		aMorph position: 0 @ 0 ]
	ifFalse:[			
		aBoolean 
		ifTrue: [ aMorph color: Color white.
			         button borderColor: Color gray.
				   button color: Color gray ]
		ifFalse:[ aMorph color: Color black.
			            button borderColor: Color gray.
					button color: Color white ].
		button extent: (aMorph width + 6) @ (aMorph height + 2).
		aMorph position: 3 @ 1 ]! !

Object subclass: #GLMMorphicIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMMorphicIcons class methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:45'!
form16x16FromContents: aByteArray 
	^ Form
	extent: 16@16
	depth: 32
	fromArray: aByteArray 
	offset: 0@0! !

!GLMMorphicIcons class methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:45'!
toolbarMenuForm
	^self form16x16FromContents: self windowMenuFormContents ! !

!GLMMorphicIcons class methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:46'!
toolbarMenuInactiveForm
	^self form16x16FromContents: self windowMenuInactiveFormContents ! !

!GLMMorphicIcons class methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:44'!
windowMenuFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 0 0 0 0 369098752 3556769792 3556769792 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 369098752 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!GLMMorphicIcons class methodsFor: 'as yet unclassified' stamp: 'tg 11/20/2010 15:45'!
windowMenuInactiveFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 0 0 0 0 377520256 3565191296 3565191296 360282489 0 0 0 0 0 0 0 0 0 0 0 0 0 377520256 360282489 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

Object subclass: #GLMMorphicPresentationToolbarModel
	instanceVariableNames: 'renderer presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
presentation
	^ presentation! !

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
presentation: anObject
	presentation := anObject! !

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
renderer
	^ renderer! !

!GLMMorphicPresentationToolbarModel methodsFor: 'accessing' stamp: 'tg 11/6/2010 11:43'!
renderer: anObject
	renderer := anObject! !

PaginatedMorphTreeMorph subclass: #GLMPaginatedResizableMorphTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMPaginatedResizableMorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/7/2014 23:51'!
resizeColumns
	| rowMorphsWidths |
	
	self columns size > 1 ifFalse: [^ self].
		rowMorphsWidths := self rowMorphsWidths.
		self allNodeMorphs do: [ :node |
			node submorphs
				inject: 1
				into: [ :index :morph |
					morph width: (rowMorphsWidths at: index).
					index + 1
				]
		].

		self hHideScrollBar.! !

!GLMPaginatedResizableMorphTreeMorph methodsFor: 'events-processing' stamp: 'AndreiChis 11/13/2014 17:35'!
toggleExpandedState: aMorph event: event
	super toggleExpandedState: aMorph event: event.
	"self resizeColumns."! !

!GLMPaginatedResizableMorphTreeMorph methodsFor: 'updating' stamp: 'AndreiChis 11/13/2014 17:35'!
updateColumnMorphs
	super updateColumnMorphs.
	"self resizeColumns."
		
	! !

MorphTreeColumn subclass: #GLMMorphTreeColumn
	instanceVariableNames: 'glamourColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMMorphTreeColumn methodsFor: 'accessing' stamp: 'tg 11/16/2009 05:01'!
glamourColumn: aColumn
	glamourColumn := aColumn! !

!GLMMorphTreeColumn methodsFor: 'column drawing' stamp: 'AndreiChis 11/13/2014 17:31'!
rowMorphFor: aNodeMorph
	| rowMorph cont |
	
	rowMorph := aNodeMorph rowMorphForColumn: glamourColumn.
	rowMorph
		ifNotNil: [rowMorph borderWidth: 0]
		ifNil: [rowMorph := self defaultRowMorph].
	cont := Morph new color: Color transparent;
				 layoutPolicy: RowLayout new;
				 hResizing: #shrinkWrap;
				 vResizing: #shrinkWrap;
				 layoutInset: container columnInset @ container rowInset;
				 yourself.
	cont addMorph: rowMorph.

	self isFirstColumn ifTrue: [ | icon |
		icon := container iconBlock value: aNodeMorph.
		icon ifNotNil: [ cont addMorph: icon asMorph ].
		"for first column we don't use horizontal inset"
		cont  layoutInset: 0 @ container rowInset.
	].
	^ cont ! !

PluggableTextMorph subclass: #GLMPluggableTextMorph
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Widgets'!

!GLMPluggableTextMorph commentStamp: 'TudorGirba 7/14/2011 09:45' prior: 0!
We subclass the default PluggableTextMorph just to raise the proper announcements when the text or when the selection changes.!

!GLMPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'TudorGirba 7/14/2011 22:40'!
announceSelection: aString from: start to: stop
	self announcer announce: (
		GLMSelectedTextChanged new 
			start: start; 
			end: stop;
			selectedText: aString )! !

!GLMPluggableTextMorph methodsFor: 'accessing' stamp: 'tg 4/15/2010 18:00'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMPluggableTextMorph methodsFor: 'do-its' stamp: 'AndreiChis 5/6/2014 14:58'!
evaluateSelectionAndDo: aBlock

	^ self handleEdit: [textMorph editor evaluateSelectionAndDo: aBlock]! !

!GLMPluggableTextMorph methodsFor: 'private' stamp: 'TudorGirba 2/8/2014 23:33'!
handleEdit: editBlock
	"We override this hook method to intercept pasting in the text morph.
	When pasting happens, we update the text port"
	super handleEdit: editBlock.
	self announcer announce: (GLMTextChanged new text: self text)! !

!GLMPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'TudorGirba 7/13/2011 18:08'!
selectFrom: start to: stop
	| result |
	result := super selectFrom: start to: stop.
	self announcer announce: (GLMSelectedTextChanged new start: start; end: stop).
	^ result! !

!GLMPluggableTextMorph methodsFor: 'new selection' stamp: 'AndreiChis 2/27/2014 17:28'!
selectLine

	self handleEdit: [ 
		textMorph editor lineSelectAndEmptyCheck: [^ nil] ].! !

!GLMPluggableTextMorph methodsFor: 'private' stamp: 'TudorGirba 7/14/2011 09:44'!
textMorphClass
	"this is needed for intercepting the shortcuts"
	^ GLMTextMorphForEditView! !

!PluggableTextMorph methodsFor: '*glamour-morphic-widgets' stamp: 'cyrilledelaunay 6/6/2011 15:57'!
setOptimalResizing
	self hResizing: #rigid.
	self vResizing: #rigid! !
GLMSmalltalkEditor initialize!
